# -*- coding: utf-8 -*-
import math
import numpy as np
import pandas as pd
from sklearn.linear_model import LogisticRegression
from sklearn import tree
from sklearn import svm
from sklearn.ensemble import GradientBoostingClassifier
from sklearn.model_selection import KFold
from sklearn.metrics import mean_squared_error
from sklearn.metrics import accuracy_score
from sklearn.linear_model import SGDClassifier
from sklearn.preprocessing import StandardScaler
from sklearn.neighbors import KNeighborsClassifier
from sklearn.ensemble import RandomForestClassifier
import matplotlib.pyplot as plt
import csv


# Load TrainData
def readnpy(TrainDataPath, TrainLabelPath, TestDataPath, TestLabelPath):
    trainData = np.load(TrainDataPath)
    trainLabel = np.load(TrainLabelPath)
    testData = np.load(TestDataPath)
    testLabel = np.load(TestLabelPath)
    return trainData,trainLabel,testData,testLabel


# LogisticRegression
def testLogisticRegression():
    print('LogisticRegression\r')
    rf2 = LogisticRegression()
    rf2.fit(trainFeatures, trainLabels)
    testPredict = rf2.predict(testFeatures)
    accuracy = accuracy_score(testPredict, testLabels)
    print(accuracy)


# decisionTree
def testDecisionTree():
    print("DecisionTree")
    model = tree.DecisionTreeClassifier(criterion='gini',max_depth=20, min_samples_leaf= 5)
    model.fit(trainFeatures, trainLabels)
    testPredict = model.predict(testFeatures)
    accuracy = accuracy_score(testPredict, testLabels)
    print(accuracy)

# randomForest
def testRandomForest():
    print('RandomForest\r')
    model = RandomForestClassifier(n_estimators=25, max_depth=None,min_samples_split=2, bootstrap=True, max_features=10)
    model.fit(trainFeatures, trainLabels)
    testPredict = model.predict(testFeatures)
    accuracy = accuracy_score(testPredict, testLabels)
    print("accuracy ",accuracy)


# KNN
def testKNN():
    print("KNN")
    model = KNeighborsClassifier(n_neighbors=10)
    model.fit(trainFeatures, trainLabels)
    testPredict = model.predict(testFeatures)
    accuracy = accuracy_score(testPredict, testLabels)
    print(accuracy)


# SVC
def testSVC():
    print('SVC')
    model = svm.SVC(kernel="poly")
    model.fit(trainFeatures, trainLabels)
    testPredict = model.predict(testFeatures)
    accuracy = accuracy_score(testPredict, testLabels)
    print(accuracy)


# GBDT
def testGBDT():
    print('GBDT')
    model = GradientBoostingClassifier()
    model.fit(trainFeatures, trainLabels)
    testPredict = model.predict(testFeatures)
    accuracy = accuracy_score(testPredict, testLabels)
    print(accuracy)



if __name__ == '__main__':
    TrainDataPath, TrainLabelPath, TestDataPath, TestLabelPath = "eventTrain.npy", "eventTrainLabel_v2.npy", "eventTest_v2.npy", "eventTestLabel_v2.npy"
    trainFeatures, trainLabels, testFeatures, testLabels = readnpy(TrainDataPath, TrainLabelPath, TestDataPath, TestLabelPath)
    trainFeatures = np.nan_to_num(trainFeatures)
    testFeatures = np.nan_to_num(testFeatures)
    testLogisticRegression()
    testRandomForest()
    testDecisionTree()
    testKNN()
    # testSVC()
    testGBDT()

