#conding=utf8
import os
import html
import numpy as np
import pandas as pd
import jieba
from dataPreprocess import checkFormat
import pickle
import re
from keras.models import Sequential, load_model
from keras.layers import Dense, Activation, Dropout, Embedding
from keras.layers import LSTM, GRU, Conv1D, Bidirectional, Layer
import gensim
import attention
from keras import backend as K
from keras import initializers, regularizers, constraints
MaxLength = 50


def readnpy(pathList):
	data = []
	for path in pathList:
		file = np.load(path)
		data.append(file)
	return data


def word2representation(path):
	file = open(path,'rb')
	model = gensim.models.KeyedVectors.load_word2vec_format('sgns.weibo.bigram-char')
	train, test = pickle.load(file)
	trainText = train['text'].to_list()
	testText = test['text'].to_list()

	trainLabel = train['label'].to_list()
	trainLabel = np.array([[int(i)] for i in trainLabel])
	testLabel = test['label'].to_list()
	testLabel = np.array([[int(i)] for i in testLabel])

	# trainText = trainText[:20]
	# testText = testText[:20]
	# trainLabel = trainLabel[:20]
	# testLabel = testLabel[:20]


	def text2representation(doc):
		docVector = []
		count = 1
		tmp = [0 for i in range(300)]
		for text in doc:
			print(count)
			count += 1
			textVector = []
			text = re.sub('[a-zA-Z0-9’!"#$%&\'()*+,-./:;<=>?@，。?★、…【】《》？“”‘’！[\\]^_`{|}~\s]+', "", text)
			text = list(jieba.cut(text))
			for word in text:
				if word in model.vocab:
					textVector.append(model[word])
			if len(textVector)<MaxLength:
				# textVector=textVector+(MaxLength-len(textVector))*np.zeros(300)
				for i in range(MaxLength-len(textVector)):
					textVector.append(np.zeros(300))
			else:
				textVector=textVector[:MaxLength]
			# textVector /= len(text)
			docVector.append(textVector)
		return docVector


	trainList = np.array(text2representation(trainText))
	testList = np.array(text2representation(testText))
	vocabSize = len(model.vocab)
	np.save("preprocessResult/w2v/full_w2vTrain.npy", trainList)
	np.save("preprocessResult/w2v/full_w2vtest.npy", testList)
	np.save("preprocessResult/w2v/full_w2vTrainLabel.npy", trainLabel)
	np.save("preprocessResult/w2v/full_w2vTestLabel.npy", testLabel)
	np.save("preprocessResult/w2v/full_w2vVocabSize.npy", np.array(vocabSize))
	return trainList, testList, trainLabel, testLabel, vocabSize


def rnn(pattern, trainData, trainLabel, testData, testLabel, inputDim, maxLength=MaxLength):
    model = Sequential()
    # model.add(Embedding(inputDim, 256, input_length=maxLength))
    # print("shape ",trainData.shape)
    if pattern == 0:
    	# model.add(LSTM(128, input_shape=(128,128,300), return_sequences=True))
    	model.add(Bidirectional(LSTM(128,input_shape=(50,300),return_sequences=True)))
    	model.add(attention.AttentionWithContext())
    	model.add(Bidirectional(LSTM(128,input_shape=(50,300))))
    	# model.add(Conv1D(32, kernel_size=3, activation='elu', padding='same', input_shape=(300, 128)))
    else:
    	model.add(Bidirectional(GRU(128,input_shape=(50,300),return_sequences=True)))
    	model.add(attention.AttentionWithContext())
    	model.add(Bidirectional(GRU(128,input_shape=(50,300))))

    model.add(Dropout(0.5))    
    
    model.add(Dense(1))
    model.add(Activation('sigmoid'))
    model.compile(
        loss='binary_crossentropy', optimizer='adam', metrics=['accuracy'])
    # model.build((None, 128,300))
    # model.summary()
    model.fit(
        trainData[0: int(len(trainData)*0.8)],
        trainLabel[0: int(len(trainLabel)*0.8)],
        batch_size=128,
        nb_epoch=10,
        validation_data=(trainData[int(len(trainData)*0.8):], trainLabel[int(len(trainLabel)*0.8):])
        )

    score = model.evaluate(testData, testLabel, batch_size=128)
    print(score)
    # model.save('model_' + language + '.h5')


if __name__ == "__main__":
	# trainList, testList, trainLabel, testLabel, vocabSize = word2representation('preprocessResult/weiboFullText.pkl')
	# print(trainList.shape, trainLabel.shape, testList.shape, testLabel.shape)
	pathList = ["w2vTrain_v2.npy","w2vTest_v2.npy","w2vTrainLabel_v2.npy","w2vTestLabel_v2.npy","w2vVocabSize_v2.npy"]
	pathList = ["preprocessResult/w2v/"+i for i in pathList]
	data = readnpy(pathList)
	trainList, testList, trainLabel, testLabel, vocabSize = data[0],data[1],data[2],data[3], int(data[4])
	# print(trainList.shape)
	# trainList, testList, trainLabel, testLabel = trainList[:300], testList[:300], trainLabel[:300], testLabel[:300]
	rnn( 0, trainList, trainLabel, testList, testLabel, vocabSize)
	# for i in trainList:
	# 	print(i)
# checkFormat("weiboText.pkl")