#conding=utf8
import os 
import io
import sys
import json
import pandas as pd
import pickle
import random
import numpy as np
# sys.stdout = io.TextIOWrapper(sys.stdout.buffer,encodin+g='utf8')

# reload(sys)   
# sys.setdefaultencoding('utf8')   

def checkFormat(path):
	file = open(path, 'rb')
	train, test = pickle.load(file)
	print(type(train))
	# print(text[0])
	print(test.head())


def textProcessing(pattern, savePath):
	dataFolder = os.walk("RNN-DetectionData\\data")  

	text = []
	label = []
	num = 100
	# print("!")
	for path,dir_list,file_list in dataFolder:  
		# print("?")
		for file_name in file_list:  
			print(os.path.join(path, file_name) )
			file = open(os.path.join(path, file_name), encoding='utf-8')
			js = json.load(file, encoding='utf-8')
			# js:list,js[0]:dict
			print("file_name ", file_name)
			if pattern == 0:
				# 只考虑发布者内容
				text.append(js[0]['text'])
				label.append(js[0]['verified'])
			else:
				# 考虑发布者和转发者内容
				subText = ''
				for weibo in js:
					# if weibo['text'] == "转发微博。":
					# 	continue
					# else:
					subText += weibo['text']
				text.append(subText)
				label.append(weibo['verified'])
			file.close()
	index = [i for i in range(len(text))]
	random.shuffle(index)
	
	trainText = [ text[index[i]] for i in range(0, int(len(text)*0.7))]
	trainLabel = [ label[index[i]] for i in range(0, int(len(text)*0.7))]
	testText = [ text[index[i]] for i in range(int(len(text)*0.7), len(text))]
	testLabel = [ label[index[i]] for i in range(int(len(text)*0.7), len(text))]
	trainDf = pd.DataFrame({"text":trainText, "label":trainLabel})
	testDf = pd.DataFrame({"text":testText, "label":testLabel})
	
	pklFile = (trainDf, testDf)
	filePath = open(savePath, 'wb')
	pickle.dump(pklFile, filePath, -1)


# first normalize, then calculate softmax
def avgSoftmax(timeList): 
	newTimeList = []
	for time in timeList:
		expTime = time/np.sum(time)
		expTime = expTime/np.sum(expTime)
		for exp in expTime:
			if exp>1 or exp<0:
				print("****************************************************")
				print(expTime)
				break
		Time = list(expTime/np.sum(expTime))
		newTimeList.append(Time)
	return newTimeList

def eventProcessing(savePath):
	dataFolder = os.walk("RNN-DetectionData\\data")
	totalText = []
	totalLabel = []
	totalTimeAvg, totalTimeVar = [], []
	timeStep = 8
	count=0
	for path, dir_list, file_list in dataFolder:  
		for file_name in file_list:  
			# file_name = "10031994215.json"
			count += 1
			file = open(os.path.join(path, file_name), encoding='utf-8')
			# print(file_name)
			js = json.load(file, encoding='utf-8')
			startTime = js[0]['t']
			endTime = js[-1]['t']
			text, time = [], []
			totalLabel.append(js[0]['verified'])
			lastingTime = endTime - startTime
			maxContiIntLen = 0
			l = timeStep
			# print("total time ",lastingTime," start time",startTime, "end time ",endTime)
			for weibo in js:
				text.append(weibo['text'])
				time.append(weibo['t'])
			# print("total len ",len(time), time[-1])
			k=0
			while True:
				empty = True
				eventText, eventTime = [], []
				emptyInterval = [-1]
				startIndex = 0
				intervalTime = lastingTime/l
				# print("inter ",intervalTime)
				for t in range(int(l)):
					intervalText, tmp, intervalTime = [], [], []
					empty = True
					for weiboIndex in range( startIndex, len(text)):
						if time[weiboIndex] <= startTime+(t+1)*lastingTime/l:
							empty = False
							intervalText.append(text[weiboIndex])
							intervalTime.append(time[weiboIndex]-startTime-t*lastingTime/l)
							tmp.append(time[weiboIndex])
						else:
							# 超出当前时间区间，进入下一时间区间
							startIndex = weiboIndex
							eventText.append(intervalText)
							eventTime.append(intervalTime)
							if empty==True:
								# print("empty ",t)
								emptyInterval.append(t)
							# else:
							#	 print("full ",t)
							break
				# 最后一个区间不会超出当前区间，因而没有被加入eventText
				eventText.append(intervalText)
				eventTime.append(intervalTime)
				# print("interval len", len(eventText))
				maxContiInterval = [0, 0]
				emptyInterval.append(l)
				for ind in range(1,len(emptyInterval)):
					if emptyInterval[ind]-emptyInterval[ind-1] > maxContiInterval[1]-maxContiInterval[0]:
						maxContiInterval[0] = emptyInterval[ind-1]
						maxContiInterval[1] = emptyInterval[ind]
				maxContiInterval[0] += 1
				maxContiInterval[1] -= 1
				# print(maxContiInterval)
				# print("max conti len ",maxContiInterval[1]-maxContiInterval[0]+1," before ",maxContiIntLen)
				if maxContiInterval[1]-maxContiInterval[0]+1<timeStep and maxContiInterval[1]-maxContiInterval[0]+1>maxContiIntLen:
					l = l/2
					maxContiIntLen = maxContiInterval[1]-maxContiInterval[0]+1
				else:
					# 达成终止条件，退出while循环
					subText, subTimeAvg, subTimeVar = [], [], []
					for i in range(int(maxContiInterval[0]), int(maxContiInterval[1]+1)):
						subText.extend(eventText[i])
						subTimeVar.append(int(np.std(eventTime[i])))
						subTimeAvg.append(int(np.mean(eventTime[i])))
					totalText.append(subText)
					totalTimeAvg.append(subTimeAvg)
					totalTimeVar.append(subTimeVar)
					# eventText = [ eventText[ind] for ind in range(len(eventText)) if ind>=maxContiInterval[0] and ind<=maxContiInterval[1]]
					break
		# debug
		# 	if count==20:
		# 		break
		# break
		# 	print('empty ',emptyInterval)
		# 	print('conti ',maxContiInterval[0], maxContiInterval[1])
			file.close()
	for i in range(len(totalText)):
		totalText[i] = ''.join(text for text in totalText[i])
	totalTimeAvg = avgSoftmax(totalTimeAvg)
	totalTimeVar = avgSoftmax(totalTimeVar)
	# print("text ",totalText[0][:5])
	# print("timeAvg  ",totalTimeAvg)
	# print("timeVar ",totalTimeVar)
	# print("label ",totalLabel)
	# print(type(totalTimeAvg[0]))
	# print("type ",type(totalTime[0][0]))
	index = [i for i in range(len(totalText))]
	random.shuffle(index)
	trainText = [ totalText[index[i]] for i in range(0, int(len(totalText)*0.7))]
	trainLabel = [ totalLabel[index[i]] for i in range(0, int(len(totalText)*0.7))]
	trainTimeAvg = [ totalTimeAvg[index[i]] for i in range(0, int(len(totalText)*0.7))]
	trainTimeVar = [ totalTimeVar[index[i]] for i in range(0, int(len(totalText)*0.7))]
	testText = [ totalText[index[i]] for i in range(int(len(totalText)*0.7), len(totalText))]
	testLabel = [ totalLabel[index[i]] for i in range(int(len(totalText)*0.7), len(totalText))]
	testTimeAvg = [ totalTimeAvg[index[i]] for i in range(int(len(totalText)*0.7), len(totalText))]
	testTimeVar = [ totalTimeVar[index[i]] for i in range(int(len(totalText)*0.7), len(totalText))]
	trainDf = pd.DataFrame({"text":trainText, "label":trainLabel,'timeAvg':trainTimeAvg,'timeVar':trainTimeVar})
	testDf = pd.DataFrame({"text":testText, "label":testLabel,'timeAvg':testTimeAvg,'timeVar':testTimeVar})
	pklFile = (trainDf, testDf)
	filePath = open(savePath, 'wb')
	pickle.dump(pklFile, filePath, -1)



if __name__ == "__main__":
	# print("**************************************event**********************************\n\n\n")
	# eventProcessing(savePath="eventPickle_v3.pkl")
	# checkFormat("eventPickle.pkl")
	# print("\n\n\n**************************************text**********************************")
	# textProcessing(pattern=1, savePath="weiboFullText.pkl")
	checkFormat("eventPickle_v3.pkl")
	# savePickle(pattern=0, path="weiboText.pkl")
	# checkFormat("weiboText.pkl")
	